/*la prima parte gestisce la connessioe con le agenzie turistiche che mandano il codice operativo
dell'operazione che vogliono effettuare. Ogni data base, per, deve anche tenere aperto un thread che 
risponda alle richieste del thread_di_configurazione che  lanciato dal name_server. Dunque i 
data base hanno la porta 6001 aperta per le agenzie di volo con una socket stream, e la porta 6000
aperta col thread_di_configurazione con una socket di tipo datagram (dato che il thread_di_configurazione 
apre una MulticastSocket; deve rispondere con l'indirizzo fisico.
Attenzione perch c' anche il thread_di_aggiornamento del data base da
considerare*/

package SocketProgetto;

import java.io.*;
import java.net.*;

public class data_base{

lista_volo lvolo;
lista_prenotazione lprenotazione;
boolean attivo;
InetAddress primo_discendente,secondo_discendente;
ServerSocket ds1,ds2;

public data_base(){
  try{
   lvolo=new lista_volo_default().riempi();
   lprenotazione=new lista_prenotazione_default().riempi();
   attivo=false;
   primo_discendente=InetAddress.getLocalHost();
   secondo_discendente=InetAddress.getLocalHost();
   }
  catch(UnknownHostException e){
     System.out.println("Errore nel costruttore del data_base: "+e);
     }
  } 

public data_base(boolean att){
  try{
   lvolo=new lista_volo_default().riempi();
   lprenotazione=new lista_prenotazione_default().riempi();
   attivo=att;
   primo_discendente=InetAddress.getLocalHost();
   secondo_discendente=InetAddress.getLocalHost();
   }
  catch(UnknownHostException e){
     System.out.println("Errore nel costruttore del data_base: "+e);
     }
  } 

public data_base(boolean att,InetAddress primo,InetAddress secondo){
   lvolo=new lista_volo_default().riempi();
   lprenotazione=new lista_prenotazione_default().riempi();
   attivo=att;
   primo_discendente=primo;
   secondo_discendente=secondo;
   } 
   
public void connetti(){
 try{
  thread_isAlive_data_base tia=new thread_isAlive_data_base(this);
  tia.start();      
  
  thread_attivazione_data_base tadb=new thread_attivazione_data_base(lvolo,lprenotazione,
            attivo,primo_discendente,secondo_discendente,this);  
  tadb.start();   
  
  ds1=new ServerSocket(6001);
  ds2=new ServerSocket(6003);
  /*sulla porta 6001 aspetta le richieste delle agenzie turistiche; 
  sulla porta 6003 aspetta le richieste delle agenzie aeree;
  sulla porta 6000 aspetta gli aggiornamenti;
  sulla porta 5999 aspetta le richieste isAlive.*/
      
      thread_aggiornamento_lprenotazione_discendenti tapd=new thread_aggiornamento_lprenotazione_discendenti(lprenotazione,this);
      tapd.start(); 
         
      thread_aggiornamento_lprenotazione_discendenti_aer tapa=new thread_aggiornamento_lprenotazione_discendenti_aer(lprenotazione,this);
      tapa.setPriority(tapd.getPriority()+1);
      tapa.start(); 

      
      thread_aggiornamento_lvolo_discendenti tavd=new thread_aggiornamento_lvolo_discendenti(lvolo,this);
      tavd.setPriority(tapd.getPriority()+1);
      tavd.start();
      
      thread_gestione_richiesta_agenzia_tur tgr=new thread_gestione_richiesta_agenzia_tur(lvolo,lprenotazione,attivo,ds1,primo_discendente,secondo_discendente,
            tadb,this);
      tgr.setPriority(tgr.getPriority()-1);
      tgr.start();
      
      thread_gestione_richiesta_agenzia_aer tga=new thread_gestione_richiesta_agenzia_aer(lvolo,lprenotazione,attivo,ds2,primo_discendente,secondo_discendente,
            tadb,this);
      tga.setPriority(tgr.MAX_PRIORITY);      
      tga.start();   
    }
   catch(SocketException e0){
      System.out.println("Errore nell'apertura della socket(Data Base): " +e0);
      }
   catch(SecurityException e1){
      System.out.println("Errore di sicurezza (Data Base): "+e1);
      }
   catch(IOException e2){
      System.out.println("Errore nella ricezione di dati(Data Base) "+e2);
      }
   catch(IllegalArgumentException e3){
      System.out.println("Errore nella connecet(Data Base): "+e3);
      }
   }   

public boolean getAttivo(){
   return attivo;
   }
   
public void setPrimo_discendente(InetAddress primo){
   primo_discendente=primo;
   }

public void setSecondo_discendente(InetAddress secondo){
   secondo_discendente=secondo;
   }

public void setAttivo(){
   attivo=true;
   } 
   
public InetAddress getPrimo_discendente(){
   return primo_discendente;
   }
   
public InetAddress getSecondo_discendente(){
   return secondo_discendente;
   }
   
public void setLista_volo(lista_volo lv){
   lvolo=lv;
   }
   
public void setLista_prenotazione(lista_prenotazione lp){
   lprenotazione=lp;
   }  
   
public lista_volo getLista_volo(){
   return lvolo;
   }
   
public lista_prenotazione getLista_prenotazione(){
   return lprenotazione;
   }
}


