/*Questa  la classe che implementa la lista delle prenotazioni, 
  quindi mi serve per definire le liste che costituiscono una 
  parte delle informazioni contenute nel data_base*/
  
package SocketProgetto;

import java.util.*;

public class lista_prenotazione{

   Vector vect=new Vector(10,5);
   
public lista_prenotazione(prenotazione prenot1){
    vect.add(prenot1);
    }
    
    
public lista_prenotazione(Vector vect1){
   vect=vect1;
   }
   
   
public lista_prenotazione(){
   vect=new Vector(10,5);
   }
   

public int size(){
   return vect.size();
   }
   
   
public prenotazione getHead(){
   try{
      if(vect.isEmpty())
         return new prenotazione();
      prenotazione pren=(prenotazione)vect.elementAt(0);
      return pren;
      }
   catch(ArrayIndexOutOfBoundsException e){
      System.out.println("Eccezione: all'indice 0 non c' nulla; "+e);
      return new prenotazione();
      }      
   }
   
   
public String getSigla_volo(int ind){
   return this.prenotazione_di_indice(ind).getSigla_volo();
   }


public int getNumero_posti_disponibili(int ind){
   return this.prenotazione_di_indice(ind).getNumero_posti_disponibili();
   }
   
   
public String getGiorno_scadenza(int ind){
   return this.prenotazione_di_indice(ind).getGiorno_scadenza();
   }
   

public String getMese_scadenza(int ind){
   return this.prenotazione_di_indice(ind).getMese_scadenza();
   }
   
   
public lista_prenotazione aggiungi_prenotazione(prenotazione pren1){
/*questa oparazione e' fatta dal thread che inserisce il volo all'interno della lista_volo
  in modo da dare la possibilita' alle agenzie di prenotarsi; il numero di posti indicati
  sono quelli totali, che man mano le agenzie andranno a decerementare*/  
   vect.add(pren1);
   return new lista_prenotazione(vect);
   }
  
  
public lista_prenotazione aggiungi_prenotazione(String sigla,int num,String giorno_sc,String mese_sc){
   prenotazione pren1=new prenotazione(sigla, num,giorno_sc,mese_sc);
   vect.add(pren1);
   return new lista_prenotazione(vect);
   }  
  
  
public lista_prenotazione cancella_prenotazione(String sigla){
/*questo metodo  usato dal thread che cancella la possibilit di prenotazione
  per i voli ormai scaduti*/
  try{
   int dimensione=vect.size(),i=0;
   while(i<dimensione){
      if((sigla.compareTo(this.prenotazione_di_indice(i).getSigla_volo()))==0){    
           vect.removeElementAt(i);
           return new lista_prenotazione(vect);
           }
      i++;
      }
   System.out.println("Nella lista delle prenotazioni non esiste il volo con la sigla "+sigla+" quindi non e' possibile cancellare questa voce della lista");
   return this;
   }
  catch(ArrayIndexOutOfBoundsException e){
   System.out.println("Errore nella 'cancella_prenotazione' (non e' possibile fare la prenotazione): "+e);
   return this;
   }  
  }
  
     
public lista_prenotazione elimina_prenotazioni_scadute(String giorno,String mese){
/*questo  un metodo invocato una volta al giorno dal thread addetto alla cancellazione
  delle prenotazioni scadute nella lista delle prenotazioni*/
  try{
   int dimensione=vect.size(),i=0;
   while(i<dimensione){
      if(this.prenotazione_scaduta(this.prenotazione_di_indice(i),giorno,mese))
         vect.removeElementAt(i);
      i++;
      }
   return new lista_prenotazione(vect);
   }
  catch(ArrayIndexOutOfBoundsException e){
     System.out.println("Errore nella 'elimina_prenotazioni_scadute' : "+e);
     return this;
     }
   }
   
   
public boolean prenotazione_scaduta(prenotazione pren1,String giorno,String mese){
/*metodo invocato dall'agenzia turistica per sapere se  ancora possibile prenotarsi o no ad un
  certo volo: l'agenzia passa la data odierna e il metodo restituisce true se non ci si pu pi prenotare*/  
   int index=this.indice_della_prenotazione(pren1.getSigla_volo());
   prenotazione pren2=this.prenotazione_di_indice(index);
   String gior2=pren2.getGiorno_scadenza();
   String mese2=pren2.getMese_scadenza();
   if((mese2.compareTo(mese))<0) return true;
   if((gior2.compareTo(giorno))<0) return true;
   return false;
   }
   
   
public boolean prenotazione_scaduta(String sigla,String giorno,String mese){
/*metodo invocato dall'agenzia turistica per sapere se  ancora possibile prenotarsi o no ad un
  certo volo: l'agenzia passa la data odierna e il metodo restituisce true se non ci si pu pi prenotare*/  
   int index=this.indice_della_prenotazione(sigla);
   if(index>=0){
      prenotazione pren2=this.prenotazione_di_indice(index);
      String gior2=pren2.getGiorno_scadenza();
      String mese2=pren2.getMese_scadenza();
      if((mese2.compareTo(mese))<0) return true;
      if((gior2.compareTo(giorno))<0) return true;
      return false;
      }
   else System.out.println("Prenotazione non trovata");
   return false;
   }
  
public lista_prenotazione fai_prenotazione(prenotazione pren1){
/*questo metodo  utilizzato dalle agenzie turistiche che vogliono prenotare un volo;
  funziona cos:passo una prenotazione che voglio fare e se possibile vado a modificare la
  lista delle prenotazioni*/  
   int index=this.indice_della_prenotazione(pren1.getSigla_volo());
   String giorno1=pren1.getGiorno_scadenza();
   String mese1=pren1.getMese_scadenza();
   /*in questi giorno e mese ho l'indicazione della data corrente:infatti l'agenzia che vuole fare la prenotazione
   fa la richiesta al data base passando la data corrente; ora devo fare un controllo
   per vedere se l'agenzia  arrivata troppo tardi*/
   if(index>=0){
      prenotazione pren2=this.prenotazione_di_indice(index);
      if(!prenotazione_scaduta(pren1,giorno1,mese1)){
         int num2=pren2.getNumero_posti_disponibili();
         if(num2>=pren1.getNumero_posti_disponibili()){
            int nuovo_numero=num2-pren1.getNumero_posti_disponibili();
            prenotazione pren3=pren2.modifica_numero_posti(nuovo_numero);
            this.cancella_prenotazione(pren2.getSigla_volo());
            this.aggiungi_prenotazione(pren3);
            }  
          else System.out.println("Ci sono solo "+num2+" posti disponibili, quindi non posso fare la prenotazione");
          }
       else System.out.println("E' troppo tardi per prenotarsi");
       }   
    else System.out.println("Non esiste questo volo quindi non lo si puo' prenotare");    
    return this;
    }
    
    
public lista_prenotazione fai_prenotazione(String sigla,int num,String giorno,String mese){
   int index=this.indice_della_prenotazione(sigla);
   if(index>=0){
      prenotazione pren2=this.prenotazione_di_indice(index);
      if(!prenotazione_scaduta(pren2,giorno,mese)){
         int num2=pren2.getNumero_posti_disponibili();
         if(num2>=num){
            int nuovo_numero=num2-num;
            prenotazione pren3=pren2.modifica_numero_posti(nuovo_numero);
            this.cancella_prenotazione(pren2.getSigla_volo());
            this.aggiungi_prenotazione(pren3);
            }  
          else System.out.println("Ci sono solo "+num2+" posti disponibili, quindi non posso fare la prenotazione");
          }
       else System.out.println("E' troppo tardi per prenotarsi");
       }
    else System.out.println("Non esiste questo volo quindi non lo si puo' prenotare");    
    return this;
    }
    

public lista_prenotazione ritira_prenotazione(prenotazione pren){
   int posti_da_restituire=pren.getNumero_posti_disponibili();
   String sigla=pren.getSigla_volo();
   String giorno=pren.getGiorno_scadenza();
   String mese=pren.getMese_scadenza();
   int index=this.indice_della_prenotazione(sigla);
   prenotazione pren1=this.prenotazione_di_indice(index);
   int nuovo_num_posti=pren1.getNumero_posti_disponibili()+posti_da_restituire;
   prenotazione new_pren=new prenotazione(sigla,nuovo_num_posti,giorno,mese);
   vect.removeElement(pren1);
   vect.add(new_pren);
   return new lista_prenotazione(vect);
   }
   
   
public boolean contiene_possibilita_di_prenotazione(String sigla){
   int dimensione=vect.size();
   int i=0;
   while(i<dimensione){
      if((sigla.compareTo(this.prenotazione_di_indice(i).getSigla_volo()))==0)
         return true;
      i++;
      }
   return false;
   }
   

public int indice_della_prenotazione(prenotazione pren1){
   return vect.indexOf(pren1);
   }
   
   
public int indice_della_prenotazione(String sigla){
   int dimensione=vect.size();
   int i=0;
   while(i<dimensione){
      if ((sigla.compareTo(this.prenotazione_di_indice(i).getSigla_volo()))==0)
         return i;
      i++;
      }
   System.out.println("Non c'e' nessun volo prenotabile con la sigla "+sigla);
   return -1;
   }
   
   
public prenotazione prenotazione_di_indice(int index){
   try{
      prenotazione pren=(prenotazione)vect.elementAt(index);
      return pren;
      }
   catch(ArrayIndexOutOfBoundsException e){
      System.out.println("L'indice "+index+" e'invalido : "+e);
      return new prenotazione();
      }
   }
   
   
public String stampa_lista_prenotazione(){   
   int dimensione=vect.size();
   int i=0;
   String str=new String("\n LISTA DELLE PRENOTAZIONI \n \n");
   while(i<dimensione){
      str=str.concat(this.prenotazione_di_indice(i).stampa_prenotazione()+"\n");
      i++;
      }
   return str;
   }
}

